using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace CADViewXDemoC_NET
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem mmiFile;
		private System.Windows.Forms.MenuItem miOpen;
		private System.Windows.Forms.MenuItem miSaveAs;
		private System.Windows.Forms.MenuItem miClose;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem miPrint;
		private System.Windows.Forms.MenuItem miPrintPreview;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem mmiView;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem menuItem17;
		public System.Windows.Forms.StatusBarPanel sbpFileName;
		public System.Windows.Forms.StatusBarPanel sbpSize;
		public System.Windows.Forms.StatusBarPanel sbpCoords;
		private AxCADViewLib.AxCADViewX CADViewX1;
		private System.Windows.Forms.MenuItem miExit;
		private System.Windows.Forms.MenuItem miZoomIn;
		private System.Windows.Forms.MenuItem miZoomOut;
		private System.Windows.Forms.MenuItem miFitWindow;
		private System.Windows.Forms.MenuItem miWithoutBorder;
		private System.Windows.Forms.MenuItem miRot90;
		private System.Windows.Forms.MenuItem miRot_90;
		private System.Windows.Forms.MenuItem miShowLayers;
		private System.Windows.Forms.MenuItem miOptions;
		private System.Windows.Forms.MenuItem miShToolBar;
		private System.Windows.Forms.MenuItem miShLayoutsBar;
		private System.Windows.Forms.MenuItem miShOptions;
		private System.Windows.Forms.MenuItem miLoadCfg;
		private System.Windows.Forms.MenuItem miSaveCfg;
		private System.Windows.Forms.MenuItem mmiAbout;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.MenuItem miPrevScale;
		private System.Windows.Forms.OpenFileDialog openFileDialog;
		private System.Windows.Forms.ProgressBar progressBar;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mmiFile = new System.Windows.Forms.MenuItem();
			this.miOpen = new System.Windows.Forms.MenuItem();
			this.miSaveAs = new System.Windows.Forms.MenuItem();
			this.miClose = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.miPrint = new System.Windows.Forms.MenuItem();
			this.miPrintPreview = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.miExit = new System.Windows.Forms.MenuItem();
			this.mmiView = new System.Windows.Forms.MenuItem();
			this.miZoomIn = new System.Windows.Forms.MenuItem();
			this.miZoomOut = new System.Windows.Forms.MenuItem();
			this.miPrevScale = new System.Windows.Forms.MenuItem();
			this.miFitWindow = new System.Windows.Forms.MenuItem();
			this.miWithoutBorder = new System.Windows.Forms.MenuItem();
			this.miRot90 = new System.Windows.Forms.MenuItem();
			this.miRot_90 = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.miShowLayers = new System.Windows.Forms.MenuItem();
			this.miOptions = new System.Windows.Forms.MenuItem();
			this.miShToolBar = new System.Windows.Forms.MenuItem();
			this.miShLayoutsBar = new System.Windows.Forms.MenuItem();
			this.miShOptions = new System.Windows.Forms.MenuItem();
			this.menuItem17 = new System.Windows.Forms.MenuItem();
			this.miLoadCfg = new System.Windows.Forms.MenuItem();
			this.miSaveCfg = new System.Windows.Forms.MenuItem();
			this.mmiAbout = new System.Windows.Forms.MenuItem();
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.sbpFileName = new System.Windows.Forms.StatusBarPanel();
			this.sbpSize = new System.Windows.Forms.StatusBarPanel();
			this.sbpCoords = new System.Windows.Forms.StatusBarPanel();
			this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.progressBar = new System.Windows.Forms.ProgressBar();
			this.CADViewX1 = new AxCADViewLib.AxCADViewX();
			((System.ComponentModel.ISupportInitialize)(this.sbpFileName)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.sbpSize)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.sbpCoords)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.CADViewX1)).BeginInit();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mmiFile,
																					  this.mmiView,
																					  this.miOptions,
																					  this.mmiAbout});
			// 
			// mmiFile
			// 
			this.mmiFile.Index = 0;
			this.mmiFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.miOpen,
																					this.miSaveAs,
																					this.miClose,
																					this.menuItem1,
																					this.miPrint,
																					this.miPrintPreview,
																					this.menuItem2,
																					this.miExit});
			this.mmiFile.Text = "File";
			// 
			// miOpen
			// 
			this.miOpen.Index = 0;
			this.miOpen.Text = "Open picture...";
			this.miOpen.Click += new System.EventHandler(this.miOpen_Click);
			// 
			// miSaveAs
			// 
			this.miSaveAs.Index = 1;
			this.miSaveAs.Text = "Save as...";
			this.miSaveAs.Click += new System.EventHandler(this.miSaveAs_Click);
			// 
			// miClose
			// 
			this.miClose.Index = 2;
			this.miClose.Text = "Close picture";
			this.miClose.Click += new System.EventHandler(this.miClose_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 3;
			this.menuItem1.Text = "-";
			// 
			// miPrint
			// 
			this.miPrint.Index = 4;
			this.miPrint.Text = "Print";
			this.miPrint.Click += new System.EventHandler(this.miPrint_Click);
			// 
			// miPrintPreview
			// 
			this.miPrintPreview.Index = 5;
			this.miPrintPreview.Text = "Print preview...";
			this.miPrintPreview.Click += new System.EventHandler(this.miPrintPreview_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 6;
			this.menuItem2.Text = "-";
			// 
			// miExit
			// 
			this.miExit.Index = 7;
			this.miExit.Text = "Exit";
			this.miExit.Click += new System.EventHandler(this.miExit_Click);
			// 
			// mmiView
			// 
			this.mmiView.Index = 1;
			this.mmiView.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.miZoomIn,
																					this.miZoomOut,
																					this.miPrevScale,
																					this.miFitWindow,
																					this.miWithoutBorder,
																					this.miRot90,
																					this.miRot_90,
																					this.menuItem11,
																					this.miShowLayers});
			this.mmiView.Text = "View";
			// 
			// miZoomIn
			// 
			this.miZoomIn.Index = 0;
			this.miZoomIn.Text = "Zoom in";
			this.miZoomIn.Click += new System.EventHandler(this.miZoomIn_Click);
			// 
			// miZoomOut
			// 
			this.miZoomOut.Index = 1;
			this.miZoomOut.Text = "Zoom out";
			this.miZoomOut.Click += new System.EventHandler(this.miZoomOut_Click);
			// 
			// miPrevScale
			// 
			this.miPrevScale.Index = 2;
			this.miPrevScale.Text = "Previous scale";
			this.miPrevScale.Click += new System.EventHandler(this.miPrevScale_Click);
			// 
			// miFitWindow
			// 
			this.miFitWindow.Index = 3;
			this.miFitWindow.Text = "Fit picture to window";
			this.miFitWindow.Click += new System.EventHandler(this.miFitWindow_Click);
			// 
			// miWithoutBorder
			// 
			this.miWithoutBorder.Index = 4;
			this.miWithoutBorder.Text = "Without border";
			this.miWithoutBorder.Click += new System.EventHandler(this.miWithoutBorder_Click);
			// 
			// miRot90
			// 
			this.miRot90.Index = 5;
			this.miRot90.Text = "Rotate +90 deg";
			this.miRot90.Click += new System.EventHandler(this.miRot90_Click);
			// 
			// miRot_90
			// 
			this.miRot_90.Index = 6;
			this.miRot_90.Text = "Rotate -90 deg";
			this.miRot_90.Click += new System.EventHandler(this.miRot_90_Click);
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 7;
			this.menuItem11.Text = "-";
			// 
			// miShowLayers
			// 
			this.miShowLayers.Index = 8;
			this.miShowLayers.Text = "Show layers";
			this.miShowLayers.Click += new System.EventHandler(this.miShowLayers_Click);
			// 
			// miOptions
			// 
			this.miOptions.Index = 2;
			this.miOptions.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.miShToolBar,
																					  this.miShLayoutsBar,
																					  this.miShOptions,
																					  this.menuItem17,
																					  this.miLoadCfg,
																					  this.miSaveCfg});
			this.miOptions.Text = "Options";
			// 
			// miShToolBar
			// 
			this.miShToolBar.Index = 0;
			this.miShToolBar.Text = "Show toolbar";
			this.miShToolBar.Click += new System.EventHandler(this.miShToolBar_Click);
			// 
			// miShLayoutsBar
			// 
			this.miShLayoutsBar.Index = 1;
			this.miShLayoutsBar.Text = "Show layots toolbar";
			this.miShLayoutsBar.Click += new System.EventHandler(this.miShLayoutsBar_Click);
			// 
			// miShOptions
			// 
			this.miShOptions.Index = 2;
			this.miShOptions.Text = "Show options dialog";
			this.miShOptions.Click += new System.EventHandler(this.miShOptions_Click);
			// 
			// menuItem17
			// 
			this.menuItem17.Index = 3;
			this.menuItem17.Text = "-";
			// 
			// miLoadCfg
			// 
			this.miLoadCfg.Index = 4;
			this.miLoadCfg.Text = "Load configuration";
			this.miLoadCfg.Click += new System.EventHandler(this.miLoadCfg_Click);
			// 
			// miSaveCfg
			// 
			this.miSaveCfg.Index = 5;
			this.miSaveCfg.Text = "Save configuration";
			this.miSaveCfg.Click += new System.EventHandler(this.miSaveCfg_Click);
			// 
			// mmiAbout
			// 
			this.mmiAbout.Index = 3;
			this.mmiAbout.Text = "?";
			this.mmiAbout.Click += new System.EventHandler(this.mmiAbout_Click);
			// 
			// statusBar
			// 
			this.statusBar.CausesValidation = false;
			this.statusBar.Location = new System.Drawing.Point(0, 457);
			this.statusBar.Name = "statusBar";
			this.statusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						 this.sbpFileName,
																						 this.sbpSize,
																						 this.sbpCoords});
			this.statusBar.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.statusBar.Size = new System.Drawing.Size(720, 24);
			this.statusBar.TabIndex = 1;
			// 
			// sbpFileName
			// 
			this.sbpFileName.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.sbpFileName.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.Raised;
			this.sbpFileName.Width = 200;
			// 
			// sbpSize
			// 
			this.sbpSize.Alignment = System.Windows.Forms.HorizontalAlignment.Right;
			this.sbpSize.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.sbpSize.Width = 200;
			// 
			// sbpCoords
			// 
			this.sbpCoords.Alignment = System.Windows.Forms.HorizontalAlignment.Right;
			this.sbpCoords.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.sbpCoords.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.Raised;
			this.sbpCoords.Width = 200;
			// 
			// openFileDialog
			// 
			this.openFileDialog.Filter = @"CAD Drawings (*.dwg;*.dxf;*.plt;*.hgl;*.hg;*.hpg;*.plo;*.hp;*.hp1;*.hp2;*.hpgl;*.hpgl2;*.gl2;*.prn;*.spl;*.rtl;*.emf;*.wmf;*.cgm;*.svg)|*.dwg;*.dxf;*.plt;*.hgl;*.hg;*.hpg;*.plo;*.hp;*.hp1;*.hp2;*.hpgl;*.hpgl2;*.gl2;*.prn;*.spl;*.rtl;*.emf;*.wmf;*.cgm;*.svg";
			// 
			// progressBar
			// 
			this.progressBar.Location = new System.Drawing.Point(0, 458);
			this.progressBar.Name = "progressBar";
			this.progressBar.Size = new System.Drawing.Size(704, 23);
			this.progressBar.Step = 1;
			this.progressBar.TabIndex = 2;
			this.progressBar.Visible = false;
			// 
			// CADViewX1
			// 
			this.CADViewX1.Location = new System.Drawing.Point(0, 0);
			this.CADViewX1.Name = "CADViewX1";
			this.CADViewX1.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("CADViewX1.OcxState")));
			this.CADViewX1.Size = new System.Drawing.Size(576, 376);
			this.CADViewX1.TabIndex = 3;
			this.CADViewX1.OnProgress += new AxCADViewLib.ICADViewXEvents_OnProgressEventHandler(this.CADViewX1_OnProgress);
			this.CADViewX1.OnMouseMove += new AxCADViewLib.ICADViewXEvents_OnMouseMoveEventHandler(this.CADViewX1_OnMouseMove);
			this.CADViewX1.OnBeforeLoad += new System.EventHandler(this.CADViewX1_OnBeforeLoad);
			this.CADViewX1.OnAfterLoad += new System.EventHandler(this.CADViewX1_OnAfterLoad);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(720, 481);
			this.Controls.Add(this.CADViewX1);
			this.Controls.Add(this.progressBar);
			this.Controls.Add(this.statusBar);
			this.ImeMode = System.Windows.Forms.ImeMode.On;
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "CADViewX Control Demo for C#";
			this.Resize += new System.EventHandler(this.Form1_Resize);
			this.Activated += new System.EventHandler(this.Form1_Activated);
			((System.ComponentModel.ISupportInitialize)(this.sbpFileName)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.sbpSize)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.sbpCoords)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.CADViewX1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void mmiAbout_Click(object sender, System.EventArgs e)
		{
			CADViewX1.ShowAbout();
		}

		private void Form1_Resize(object sender, System.EventArgs e)
		{
			CADViewX1.Width = this.Width;
			if (this.Height - 3 * statusBar.Height - CADViewX1.Top > 0) 
				CADViewX1.Height = this.Height - 3 * statusBar.Height - CADViewX1.Top;
			progressBar.Top = statusBar.Top;
			progressBar.Width = statusBar.Width;
		}

		private void Form1_Activated(object sender, System.EventArgs e)
		{
			bool IsVectorial;
			IsVectorial = CADViewX1.IsVectGraphic();
			miSaveAs.Enabled = IsVectorial;
			miClose.Enabled = IsVectorial;
			miPrint.Enabled = IsVectorial;
			miPrintPreview.Enabled = IsVectorial;
			miZoomIn.Enabled = IsVectorial;
			miZoomOut.Enabled = IsVectorial;
			miPrevScale.Enabled = IsVectorial;
			miFitWindow.Enabled = IsVectorial;
			miWithoutBorder.Enabled = IsVectorial;
			miRot90.Enabled = IsVectorial;
			miRot_90.Enabled = IsVectorial;
			miShowLayers.Enabled = IsVectorial;
			this.OnResize(e);
		}

		private void CADViewX1_OnAfterLoad(object sender, System.EventArgs e)
		{
			progressBar.Value = 100;
			if (CADViewX1.IsVectGraphic())
			{
				sbpFileName.Text = CADViewX1.FileName;
				sbpSize.Text = Convert.ToString(CADViewX1.mmWidth) + " X " + 
					Convert.ToString(CADViewX1.mmHeight);
				if (CADViewX1.Millimetres)
					sbpSize.Text = "Size in millimeters: " + sbpSize.Text;						
				else
					sbpSize.Text = "Size in inches: " + sbpSize.Text;
			}
			this.statusBar.Text = sbpFileName.Text + "   " + sbpSize.Text + "   " + sbpCoords.Text;
			progressBar.Visible = false;
			this.OnActivated(e);
		}

		private void CADViewX1_OnMouseMove(object sender, AxCADViewLib.ICADViewXEvents_OnMouseMoveEvent e)
		{
			CADViewLib.tagFPoint P;
			if (CADViewX1.IsVectGraphic ())
			{
				P = CADViewX1.CADCoords(e.x, e.y);
				this.sbpCoords.Text = "(" + Convert.ToString(P.X) + "; " + 
					Convert.ToString(P.Y) + "; " + Convert.ToString(P.Z) + ")";
				this.statusBar.Text = sbpFileName.Text + "   " + sbpSize.Text + "   " + sbpCoords.Text;
			}
			else
				this.statusBar.Text = "";
		}

		private void miClose_Click(object sender, System.EventArgs e)
		{
			CADViewX1.CloseFile();
			this.OnActivated(e);
		}

		private void miExit_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void miOpen_Click(object sender, System.EventArgs e)
		{
			if (this.openFileDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
			{
				this.statusBar.Text = "";
				CADViewX1.LoadFile(openFileDialog.FileName);
			}
		}

		private void miSaveAs_Click(object sender, System.EventArgs e)
		{
			CADViewX1.DoToolButtonClick(CADViewLib.TxToolButton.tbSave);
		}

		private void miPrint_Click(object sender, System.EventArgs e)
		{
			CADViewX1.PrintImage();
		}

		private void miPrintPreview_Click(object sender, System.EventArgs e)
		{
			CADViewX1.DoToolButtonClick(CADViewLib.TxToolButton.tbPrintPreview);
		}

		private void miZoomIn_Click(object sender, System.EventArgs e)
		{
			CADViewLib.TxPoint P;
			P = CADViewX1.Center();
			CADViewX1.ScaleImage(false, 2, P.X, P.Y);
			CADViewX1.RefreshAfterRotate();
		}

		private void miZoomOut_Click(object sender, System.EventArgs e)
		{
			CADViewLib.TxPoint P;
			P = CADViewX1.Center();
			CADViewX1.ScaleImage(false, 0.5, P.X, P.Y);
			CADViewX1.RefreshAfterRotate();
		}

		private void miPrevScale_Click(object sender, System.EventArgs e)
		{
			CADViewX1.PrevScale();
		}

		private void miFitWindow_Click(object sender, System.EventArgs e)
		{
			CADViewX1.DoToolButtonClick(CADViewLib.TxToolButton.tbFitToWindow); 
		}

		private void miWithoutBorder_Click(object sender, System.EventArgs e)
		{
			CADViewX1.IsWithoutBorder = !CADViewX1.IsWithoutBorder;
		}

		private void miRot90_Click(object sender, System.EventArgs e)
		{
			CADViewX1.DXFImage().Rotate(CADViewLib.TxAxes.axisZ, 90.0);
			CADViewX1.RefreshAfterRotate();
		}

		private void miRot_90_Click(object sender, System.EventArgs e)
		{
			CADViewX1.DXFImage().Rotate(CADViewLib.TxAxes.axisZ, -90.0);
			CADViewX1.RefreshAfterRotate();
		}

		private void miShowLayers_Click(object sender, System.EventArgs e)
		{
			CADViewX1.ShowLayersDialog();
		}

		private void miShToolBar_Click(object sender, System.EventArgs e)
		{
			CADViewX1.ToolBarVisible = !CADViewX1.ToolBarVisible;
			miShToolBar.Checked = CADViewX1.ToolBarVisible;
		}

		private void miShLayoutsBar_Click(object sender, System.EventArgs e)
		{
			CADViewX1.LayoutsBarVisible = !CADViewX1.LayoutsBarVisible;
			miShLayoutsBar.Checked = CADViewX1.LayoutsBarVisible;
		}

		private void miShOptions_Click(object sender, System.EventArgs e)
		{
			CADViewX1.DoToolButtonClick(CADViewLib.TxToolButton.tbOptions);
		}

		private void miLoadCfg_Click(object sender, System.EventArgs e)
		{
			CADViewX1.LoadFromIni("Demo.ini");
		}

		private void miSaveCfg_Click(object sender, System.EventArgs e)
		{
			CADViewX1.SaveToIni("Demo.ini");
		}

		private void CADViewX1_OnProgress(object sender, AxCADViewLib.ICADViewXEvents_OnProgressEvent e)
		{
			progressBar.Value = e.percentDone;
		}

		private void CADViewX1_OnBeforeLoad(object sender, System.EventArgs e)
		{
			progressBar.Visible = true;
			progressBar.Value = 0;
		}
	}
}
